#pragma sfr
#pragma NOP
#pragma EI

#include "LCD.h"
#include "SPI.h"
#include "font.h"


// Globalϐ` 
static unsigned char global_cs = 0;
static unsigned char global_column = 0;
static unsigned char global_page = 0;
static unsigned char global_line = 0;



// LCD֐[|[g/SPI/^C}] LCD_Init(); 
void LCD_Init(void)
{

	//VpICSTROBE[q Ŋm
	SPIF_STROBE = 1;			//P12=1
	SPIF_STROBE_IO = 0;			//set P12 is output mode

	//LCD_CS1 ANeBuLo
	LCD_CS1 = 1;			//P33=1
	LCD_CS1_IO = 0;			//set P33 is output mode

	//LCD_CS2 ANeBuLo
	LCD_CS2 = 1;			//P15=1
	LCD_CS2_IO = 0;			//set P15 is output mode

	//LCD_E オA0,CSmAŃf[^m
	LCD_E = 0;			//P60=0
	LCD_E_IO = 0;			//set P60 is output mode

	//LCD_A0 R}hI 0:R}h 1:\R}h
	LCD_A0 = 0;			//P16=0
	LCD_A0_IO = 0;			//set P16 is output mode

	//LCD쓮NbNTO50
	LCD_CLK = 0;			//P17=0
	LCD_CLK_IO = 0;			//set P17 is output mode
	
	TCL50 = 0x05;		//TO50=250kHz
	CR50 = 61;			//f=2kHz
	TMC50 = 0x07;		//TMC50WX^ݒ
	TCE50 =1;			//^C}50 Start

//    CSI10_Init(0x40,0x18);                       /* CSI10 initialization function */
//    CSI10_Enable();                     /* CSI10 enable function */

}

// LCDR}hM֐ LCD_Command(cs,0xXX); 
void LCD_Command(unsigned char cs,unsigned char command)
{
	LCD_E=0;		//LCD EuLov
	LCD_A0=0;		//LCD A0uLovR}hM[h

	//LCD CSݒ
	switch (cs)
	{
		case 0:	//͉Ȃ
			LCD_CS1 = 1;			//LCD CS1uHiv
			LCD_CS2 = 1;			//LCD CS2uHiv
			break ;
		case 1:	//CS1
			LCD_CS1 = 0;			//LCD CS1uLov
			break ;
		case 2:	//CS2
			LCD_CS2 = 0;			//LCD CS2uLov
			break ;
		case 3:	//CS1,2
			LCD_CS1 = 0;			//LCD CS1uLov
			LCD_CS2 = 0;			//LCD CS2uLov
			break ;
	}

	SPIF_STROBE = 1;			//VpIC STROBE[quHiv
    SPI_Put(command);
	SPIF_STROBE = 0;			//VpIC STROBE[quLov
	LCD_E=1;		//LCD EuHiv
	NOP();
	LCD_E=0;		//LCD EuLov
	LCD_CS1 = 1;	//LCD CS1uHiv
	LCD_CS2 = 1;	//LCD CS2uHiv
	NOP();


}

// LCDf[^M֐ LCD_Data(0xXX); 
void LCD_Data(unsigned char data)
{



	LCD_E=0;		//LCD EuLov
	LCD_A0=1;		//LCD A0uLov\f[^M[h

	//LCD CSݒ
	switch (global_cs)
	{
		case 0:	//͉Ȃ
			LCD_CS1 = 1;			//LCD CS1uHiv
			LCD_CS2 = 1;			//LCD CS2uHiv
			break ;
		case 1:	//CS1
			LCD_CS1 = 0;			//LCD CS1uLov
			break ;
		case 2:	//CS2
			LCD_CS2 = 0;			//LCD CS2uLov
			break ;
		case 3:	//CS1,2
			LCD_CS1 = 0;			//LCD CS1uLov
			LCD_CS2 = 0;			//LCD CS2uLov
			break ;
	}

	NOP();

	SPIF_STROBE = 1;			//VpIC STROBE[quHiv
    SPI_Put(data);
	SPIF_STROBE = 0;			//VpIC STROBE[quLov

	NOP();
	LCD_E=1;		//LCD EuHiv
	NOP();
	LCD_E=0;		//LCD EuLov
	LCD_CS1 = 1;	//LCD CS1uHiv
	LCD_CS2 = 1;	//LCD CS2uHiv
	NOP();

	global_column++;
	if(global_column == 0)
	{
		LCD_ColumnSet(0);
	}
	LCD_SelectCS();

}


// LCDZbg֐ LCD_Reset(); 
void LCD_Reset(void)
{
    LCD_A0 = 0;			//P16=0[R}h]
    LCD_Command(3,LCD_RESET);
}

// LCDftHgZbeBO֐ LCD_DefaultSet();
void LCD_DefaultSet(void)
{
    LCD_A0 = 0;			//P16=0[R}h]
	LCD_Command(3,LCD_STATIC_OFF);	//X^eBbNhCuOFF
    LCD_Command(3,LCD_DUTY_32);		//LCD_Duty=1/32
	LCD_Command(3,LCD_ADC_F);			//Eo(])
	

	LCD_DisplayOFF();			//\OFF

}

// LCD\ON LCD_DisplayON();
void LCD_DisplayON(void)
{
    LCD_A0 = 0;			//P16=0[R}h]
    LCD_Command(3,LCD_DISP_ON);
}

// LCD\OFF LCD_DisplayOFF();
void LCD_DisplayOFF(void)
{
    LCD_A0 = 0;			//P16=0[R}h]
    LCD_Command(3,LCD_DISP_OFF);
}

// LCD Clear LCD_Clear();
void LCD_Clear(void)
{
	unsigned char i, j;
	
	for(i = 0; i <= 3 ; i++)
	{
		LCD_PageSet(i);
		LCD_ColumnSet(0);
		for(j = 0; j <=121 ; j++)
		{
			LCD_Data(0);
		}
	}

	LCD_PageSet(0);
	LCD_ColumnSet(0);
}
// LCDy[WZbg֐  LCD_PageSet(page0-3);
void LCD_PageSet(unsigned char page)
{
	page    &= 0b00000011;
	global_page  = page;
	page    |= 0b10111000;
	
	LCD_Command(3, page);
}

// LCDJZbg֐  LCD_ColumnSet(CulumnAdress00-79);
void LCD_ColumnSet(unsigned char column)
{
	unsigned char cs1_column, cs2_column;

	cs1_column = 0;
	cs2_column = 0;
	global_column = column;

	if(global_column <= 121)
	{
		if(global_column > 60)
		{
			cs2_column = global_column - 61;
		}
		else
		{
			cs1_column = global_column;
		}
	}
	LCD_SelectCS();

	LCD_Command(1, cs1_column);
	LCD_Command(2, cs2_column);
	
}

// LCD CSI֐  LCD_SelectCS(csNo.);
void LCD_SelectCS(void)
{
	if(global_column <= 121)
	{
		if(global_column > 60)
		{
			global_cs = 2;
		}
		else
		{
			global_cs = 1;
		}
	}
	else
	{
		global_cs = 0;
	}
}




// LCD 1\֐  LCD_putc(char1);
void LCD_Putc(unsigned char c)
{
	unsigned char i, j;

//c=0x35;	//u5v

	if(c > 0x7f)
	{
			i = 0x00;
	}
	else
	{
		if(c >= 0x20)
		{
			i = c - 0x20;
		}
		else
		{
			 i = 0x00;
		}
	}

	for(j = 0; j < 6; j++)
	{
		LCD_Data(font[i][j]);
	}
}

// LCD \֐  LCD_puts("XXXX",Length);
void LCD_Puts(char *c,unsigned char len)
{

	while(len)
	{
		LCD_Putc(*c);

		++c;	//c=c+1;
		len--;
	}
}

// LCD J[\ړ֐ LCD_LocateXY(x,y);
void LCD_CursorXY(unsigned char x, unsigned char y)
{
	x *= 6;

	LCD_ColumnSet(x);
	LCD_PageSet(y);
}


// LCD 1ij\֐  LCD_putc(char1);
void LCD_LPutc(unsigned char c, unsigned char x, unsigned char y)
{
	unsigned char i, j;
//	c=0x38;	//u8v
	if(c > 0x3A)
	{
			i = 0x19;
	}
	else
	{
		if(c >= 0x30)
		{
			i = c - 0x30;
		}
		else
		{
			 i = 0x19;
		}
	}

	if(c==0x6d)	i=0x0b;	//m
	if(c==0x56)	i=0x0c;	//V
	if(c==0x6b)	i=0x0d;	//k
	if(c==0x48)	i=0x0e;	//H
	if(c==0x7a)	i=0x0f;	//z
	if(c==0x40)	i=0x10;	//(@)
	if(c==0x41)	i=0x11;	//A
	if(c==0x49)	i=0x12;	//I
	if(c==0x52)	i=0x13;	//R
	if(c==0x66)	i=0x14;	//f
	if(c==0x2e)	i=0x15;	//.
	if(c==0x75)	i=0x16;	//u
	if(c==0x46)	i=0x17;	//F
	if(c==0x43)	i=0x18;	//C



	LCD_ColumnSet(x);
	LCD_PageSet(y);
	for(j = 0; j < 12; j++)
	{
		LCD_Data(font2[i][j]);
	}
	LCD_ColumnSet(x-1);	//ƎΑ̂
	LCD_PageSet(y+1);
	for(j = 0; j < 12; j++)
	{
		LCD_Data(font2[i][j+12]);
	}
}

// LCD ij\֐  LCD_puts("XXXX",Length);
void LCD_LPuts(char *c,unsigned char len, unsigned char x, unsigned char y)
{

	x *= 12;

	while(len)
	{
		LCD_LPutc(*c,x,y);
		x=x+12;
		++c;	//c=c+1;
		len--;
	}
}
