#ifndef LCD_H
#define LCD_H


#define	SPIF_STROBE	P12.0
#define	SPIF_STROBE_IO	PM12.0
#define	LCD_CS1	P3.3
#define	LCD_CS1_IO	PM3.3
#define	LCD_CS2	P1.5
#define	LCD_CS2_IO	PM1.5
#define	LCD_E	P6.0
#define	LCD_E_IO	PM6.0
#define	LCD_A0	P1.6
#define	LCD_A0_IO	PM1.6
#define	LCD_CLK	P1.7
#define	LCD_CLK_IO	PM1.7


// LCDR}h[SG12232] 
//\ON/OFF
#define LCD_DISP_ON		0xAF	//\ON
#define LCD_DISP_OFF	0xAE	//\OFF

//#define LCD_SETLINE		0b11000000		// \JnCEZbg

//y[WAhXZbg
#define LCD_PAGE_0		0xB8	//y[WAhXZbg0
#define LCD_PAGE_1		0xB9	//y[WAhXZbg1
#define LCD_PAGE_2		0xBA	//y[WAhXZbg2
#define LCD_PAGE_3		0xBB	//y[WAhXZbg3


//#define LCD_SETCOLUMN	0b00000000		//JiZOgjAhXZbg

//ADCZNg
#define LCD_ADC_F		0xA0	//0:Eo(]) Forward
#define LCD_ADC_B		0xA1	//1:o(t]) Backward

//X^eBbNhCuON/OFF
#define LCD_STATIC_OFF	0xA4	//ʏ\
#define LCD_STATIC_ON	0xA5	//X^eBbN쓮

//f[eB[ZNg
#define LCD_DUTY_16		0xA8	//0: 1/16
#define LCD_DUTY_32		0xA9	//1: 1/32

//[hfBt@C[h
#define LCD_RMODIFY_START	0xE0	//[hft@C[hJn
#define LCD_RMODIFY_END		0xEE	//[hft@C[hI

//Zbg
#define LCD_RESET		0xE2	//Zbg



// ֐` 
void LCD_Init(void);
void LCD_Command(unsigned char cs,unsigned char command);
void LCD_Data(unsigned char data);
void LCD_Reset(void);
void LCD_DefaultSet(void);
void LCD_DisplayON(void);
void LCD_DisplayOFF(void);
void LCD_Clear(void);
void LCD_PageSet(unsigned char page);
void LCD_ColumnSet(unsigned char column);
void LCD_SelectCS(void);



void LCD_Putc(unsigned char c);
void LCD_Puts(char *c,unsigned char len);

void LCD_LPutc(unsigned char c, unsigned char x, unsigned char y);
void LCD_LPuts(char *c,unsigned char len , unsigned char x, unsigned char y);


void LCD_CursorXY(unsigned char x, unsigned char y);


#endif

